ThunderLoom plugin for VRay for 3dsMax
===
*ThunderLoom is a physically based shader for woven cloth with added 
flexibility for artists. https://github.com/vidarn/ThunderLoom*
*Its shading model is based on the work by Piti Irawan
https://www.cs.cornell.edu/~srm/publications/IrawanThesis.pdf*

This plugin adds the ThunderLoom material to the V-Ray renderer and 3dsMax.
This includes a user interface for controlling the material in the 3dsMax 
material editor and a pattern editor. 

# Install
If the compiled material file (`thunderLoom.dlt`) is available, installation is
simple. Simply move the `.dlt` file to the `vrayplugins` folder in 3dsMax. 
Make sure that the `.dlt` file is meant for your version of 3dsMax!

The usual path for the plugins folder is 
`C:\Program Files\Autodesk\3dsMax (VERSION)\plugins\vrayplugins`.

# Building
In order to build the material plugin from source you will need...

* the 3dsMax SDK corresponding to your 3dsMax version
* V-Ray version 3.x (for your 3dsMax version) installed.
* Visual Studio 2012 (for 3dsMax versions later than 2014)
* cmake

The Visual Studio Project can be generated using cmake. In the `vray3dsMax`
directory run the following commands to generate the visual studio projects.
```
mkdir _build
cd _build
cmake -D3DSMAX_VERSION=2017 -G "Visual Studio 11 Win64" ..
```
The project can now be opened or built directly with ``cmake --build .``.
The resulting `.dlt` file will in this case be put in
`releases\Windows\V-Ray for 3dsMaxYYYY\thunderLoomVRay3dsMax.dlt`.

The cmake configuration assumes default install locations for 3dsMax and V-Ray. 
Should you need to change these, such as compiling for a new 3dsMax version
or you have non-standard install paths, the following cmake variables can be
used,

* `3DSMAX_VERSION` Version of 3dsMax.
* `3DSMAXSDK_ROOT` Override the autogenerated (from `3DSMAX_VERSION`) path with
an explicit path to the 3dsMax SDK.
* `3DSMAXSDK_INCLUDE` Override the autogenerated (from `3DSMAX_ROOT`) path with
an explicit path to the 3dsMax SDK include files.
* `3DSMAXSDK_LIB` Override the autogenerated (from `3DSMAX_ROOT`) path with
an explicit path to the 3dsMax SDK library files.
* `VRAY3DSMAXSDK_ROOT` Override the autogenerated (from `3DSMAX_VERSION`) path
with an explicit path to V-Ray for 3dsMax corresponding to the 3dsMax version.
* `VRAY 3DSMAXSDK_INCLUDE` Override the autogenerated (from `VRAY3DSMAX_ROOT`)
path with an explicit path to the V-Ray for 3dsMax SDK include files.
* `VRAY3DSMAXSDK_LIB` Override the autogenerated (from `VRAY3DSMAX_ROOT`) path
with an explicit path to the V-Ray for 3dsMax SDK library files.
